<?php
/**
 * @package Talki
 * @author Team Tal.ki 
 * @version 1.1.3
 */
/*
Plugin Name: Tal.ki Embeddable Forums
Plugin URI: http://wordpress.org/extend/plugins/talki-embeddable-forums/
Description: The easiest way to embed a forum onto your WordPress site.  Admin and Member roles are tightly integrated with WordPress.  Members are notified of new responses.  The forums are Search Engine Optimized (SEO) and have tons of core 'forum' features not available in other plugins.  Supports BBCode, Private & Public Forums, Permalinking, lockable & sticky topics, embedding of media and youtube videos and it will automatically bring a returning member to their last unread reply.
Author: Team Tal.ki
Version: 1.1.3
Author URI: http://tal.ki/
*/


function randstring($len) {
    $chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
    $s='';
    for($i=0;$i<$len;$i++) $s.=$chars[rand(0,strlen($chars))];
    return $s;
}

function fetch_embed_code() {
    // default installation
    $shortname = randstring(5).time();
    $fullname = $shortname."talki";
    $embed_data = array('shortname'=>$shortname, 'fullname'=>$fullname);

    $from_server = json_decode(wp_remote_fopen("http://tal.ki/new-embed-code/?json=1"), $assoc=true);    
    if(is_array($from_server) && array_key_exists("shortname", $from_server)) {
        $embed_data = $from_server;
    }
    update_option('talki_embed_data', $embed_data);
    return $embed_data;
}

function get_embed_data() {
   $embed_data = get_option('talki_embed_data');
    if(!$embed_data) {
        $old_embed_code = get_option('talki_embedcode');
        if($old_embed_code) {
            preg_match("/^.*http:\/\/([^\.]*).*/", $old_embed_code, $match);
            $shortname = $match[1];
            $embed_data = json_decode(wp_remote_fopen("http://tal.ki/upgrade/wp/1.0/$shortname/"), $assoc=true);
            update_option('talki_embed_data', $embed_data);
        }
        
        if(!$embed_data)
            $embed_data = fetch_embed_code();
    }
    return $embed_data;
}

function create_talki_page() {
    $embed_data = get_embed_data();
    $my_post = array();
    
    $page_named_forum = get_page_by_title('Forum');
    $title = "Forum";
    if($page_named_forum) $title = "Tal.ki Forum";
    
    $my_post['post_title'] = $title;
    $my_post['post_content'] = "Talki forum will be embedded on this page";
    $my_post['post_status'] = 'publish';
    $my_post['post_author'] = 1;
    $my_post['post_category'] = array(1);
    $my_post['post_type'] = 'page';
    $my_post['comment_status'] = 'closed';
    $my_post['ping_status'] = 'closed';
    
    $pid = wp_insert_post( $my_post );
    update_option('talki_pageid', $pid);
}

add_action('wp_head', 'talki_init');

/*
register_deactivation_hook( __FILE__, 'talki_deactivate' );

function talki_deactivate() {

    $page = get_page(get_option('talki_pageid'));
    if($page) {
        $page['post_status'] = 'draft';
        wp_update_post($page);
    }
}
*/

function talki_lol($content) {    
    $embed_data = get_embed_data();    
    $fullname = $embed_data['fullname'];
    $args = "";
    
    $theme_name = get_current_theme();
    $theme_data = get_theme($theme_name);

    $wrap_pre = "<style>.nocomments { display: none; }</style>";
    $wrap_post = "";
    
    if($theme_data['Name']=="WordPress Default" && strpos($theme_data['Description'], '>Kubrick<')==90) {
        $wrap_pre .= "<div style='background-color: white;'>";
        $wrap_post .= "</div>";
    }
    
    if(array_key_exists('site_key',$embed_data) && is_user_logged_in()) {
        $site_key = $embed_data['site_key'];
       $user = wp_get_current_user();
       $args = array(
           'uid'=>$user->ID,
           'name'=>$user->display_name,
           'ap'=>'site',
           'expires'=>time()+60*2,
           'domain'=>$fullname,
           'email'=>$user->user_email           
           );
       if($user->caps['administrator']) $args['level'] = 100;
   
       $sig = generate_signature($args, $site_key);
       $data = serialize_fields($args);
       $args = $data."&sig=".$sig;
    }
    $extra="";
    $footer = get_option('talki_footer');
    if($footer) $extra = '<div style="font-size:80%; text-align:center;" class="talki_promo">get your own <a href="http://tal.ki">embeddable forum</a> with Talki</div>';

    return <<<EMBED
$wrap_pre    
<script type="text/javascript" src="http://$fullname.embed.tal.ki/embed/1.js?$args"></script>
$wrap_post
$extra
EMBED;
}


function talki_init() {    
    $talkipage_id = get_option('talki_pageid');
    if(!$talkipage_id) { 
        create_talki_page();
    }
    
    $talkipage_id = get_option('talki_pageid');
    if(is_page($talkipage_id)) {
        
        $page = get_page($talkipage_id);
        if($page && $page->post_status!='publish') {
            $page->post_status = 'publish';
            wp_update_post($page);
        }
        add_filter("the_content", "talki_lol");
    }
}

/* admin menus */
add_action('admin_menu', 'talki_add_admin_menu');
function talki_add_admin_menu() {    
    add_options_page('Talki', 'Talki Options', 'administrator', 'talkioptions', 'talki_admin_options');
}

function talki_admin_options() {
    $pageurl = get_page_link(get_option('talki_pageid'));
    echo "<h2>Tal.ki - the easiest way to embed a forum</h2>";
    echo "Forum is visible at this address: <a target='_blank' href='$pageurl'>$pageurl</a>";
    
    if($_POST && $_POST['talki_options']) {  
        update_option('talki_footer', $_POST['talki_footer']=="on");        
    }

    $woot = "";
    if(get_option("talki_footer")) $woot='checked="checked"';
    echo <<<STUFF
     <form name="form_lol" method="post" action="options-general.php?page=talkioptions" style="margin: 15px 0">  
         <input type="hidden" name="talki_options" value="go"/>
         <input type="checkbox" name="talki_footer" $woot/>&nbsp;<strong>Keep Tal.ki free</strong>. Please support our plugin by displaying a link back to our site on your forum's footer
         <br>
         <input type="submit" name="submit" value="Update the setting" />  
    </form>
STUFF;

}


/* Tal.ki SSO stuff */
function serialize_fields($fields) {
    ksort($fields);
    $data = array();
    foreach ($fields as $key => $value) {
        if ($value != "") {
            $data[] = "$key=" . urlencode($value);
        }
    }
    return join("&", $data);
}

function urlsafe_base64_encode($value) {
    $res = base64_encode($value);
    $res = str_replace("+", "-", $res);
    return str_replace("/", "_", $res);
}

function generate_signature($fields, $secret_key) {
    $data = serialize_fields($fields);
    $signature = hash_hmac("sha1", $data, $secret_key, TRUE);
    return urlsafe_base64_encode($signature);
}
